MODEL ovning

TABLES
 VALG(3)                       ! Inneholder var. for bestemmelse av min. kost
 DIM(4)                        ! eller min pref.avvik, samt stoerrelsen paa M
			       ! som brukes til aa vekte funksjonene (goalp.)
DISKDATA
 VALG(1)=ovning.val
 DIM(1)=ovning.dim
LET ALFA   = VALG(1)           ! Alfa=0 -> min preferanseavvik
LET M      = VALG(2)           ! Alfa=1 -> min kostnad
LET BETA   = VALG(3)           ! Beta=0: Oppgave 12.18
LET FMAX   = DIM(1)            ! Beta=1: Oppgave 12.19
LET DMAX   = DIM(2)            ! FMAX, DMAX og KMAX er maks antall fabrikker,
LET KMAX   = DIM(3)            ! depoter og kunder
LET DLIMIT = DIM(4)            ! Valgt verdi for max ant. depoter


TABLES
 KFD(FMAX,DMAX)                ! Kostnad Fabrikk-Depot
 KFK(FMAX,KMAX)                ! Kostnad Fabrikk-Kunde
 KDK(DMAX,KMAX)                ! Kostnad Depot-Fabrikk
 PFK(FMAX,KMAX)                ! Preferanse Fabrikk-Kunde
 PDK(DMAX,KMAX)                ! Preferanse Depot-Kunde
 FKAP(FMAX)                    ! FabrikKAPasitet
 DKAP(DMAX)                    ! DepotKAPasitet (opprinnelig)
 KETT(KMAX)                    ! KundeETTerspoersel
 DKAPNY(DMAX)                  ! Depotkapasitet etter endring
 KNYDEP(DMAX)                  ! Kostnad for NYtt DEPot. Denne er
			       ! 0 for uendrede depoter og negativ
			       ! for depoter som kan selges. Positiv
			       ! ved utvidelse/nybygg

DISKDATA
 KFD(1,1)  = ovning.kfd
 KFK(1,1)  = ovning.kfk
 KDK(1,1)  = ovning.kdk
 PFK(1,1)  = ovning.pfk
 PDK(1,1)  = ovning.pdk
 FKAP(1)   = ovning.fka
 DKAP(1)   = ovning.dka
 KETT(1)   = ovning.ket
 DKAPNY(1) = ovning.dky
 KNYDEP(1) = ovning.kny

ASSIGN DMAXENDR = DLIMIT - SUM(d=1:DMAX | DKAP(d) .gt. 0) 1
			       ! Maxendring, antall depoter: grense - gamle

VARIABLES
 fd(f=1:FMAX,d=1:DMAX | KFD(f,d) .gt. 0)           ! Defineres bare der
 fk(f=1:FMAX,k=1:KMAX | KFK(f,k) .gt. 0)           ! kostnad > 0
 dk(d=1:DMAX,k=1:KMAX | KDK(d,k) .gt. 0)
 pREFAVVI                                          ! Preferanseavvik
 tOTKOST                                           ! Totalkostnad
 eNDREDEP(d=1:DMAX | (DKAPNY(d) .ne. DKAP(d)) .and. BETA == 1)
						   ! EndreDepot, = 1 hvis
						   ! nedlegger/utvider/nytt,
						   ! 0 ellers. Defineres bare
						   ! for oppgave 12.19

CONSTRAINTS
 OBJFUNK: ALFA*tOTKOST + ALFA*(1/M)*pREFAVVI + &         ! Alfa=0 -> min.
	  (1-ALFA)*pREFAVVI + (1-ALFA)*(1/M)*tOTKOST $   ! foerst pref.avvik
							 ! deretter kost.
							 ! Alfa=1 -> motsatt

 KOST: SUM(f=1:FMAX,k=1:KMAX | KFK(f,k) .gt. 0) KFK(f,k)*fk(f,k) +   &
       SUM(f=1:FMAX,d=1:DMAX | KFD(f,d) .gt. 0) KFD(f,d)*fd(f,d) +   &
       SUM(d=1:DMAX,k=1:KMAX | KDK(d,k) .gt. 0) KDK(d,k)*dk(d,k) +   &
       SUM(d=1:DMAX) BETA*KNYDEP(d)*eNDREDEP(d)                      &                
							  - tOTKOST  = 0

 AVVIK: SUM(f=1:FMAX,k=1:KMAX) PFK(f,k)*fk(f,k) +                    &
	SUM(d=1:DMAX,k=1:KMAX) PDK(d,k)*dk(d,k)                      &
							  - pREFAVVI = 0

 FABKAP(f=1:FMAX): SUM(d=1:DMAX) fd(f,d) + SUM(k=1:KMAX) fk(f,k)     < FKAP(f)

 DEPKAP(d=1:DMAX): SUM(k=1:KMAX) dk(d,k) - DKAP(d) +                 &
		   DKAP(d)*eNDREDEP(d) - DKAPNY(d)*eNDREDEP(d)       < 0

 KUNETT(k=1:KMAX): SUM(f=1:FMAX) fk(f,k) + SUM(d=1:DMAX) dk(d,k)     > KETT(k)

 MIDNOD(d=1:DMAX): SUM(f=1:FMAX) fd(f,d) - SUM(k=1:KMAX) dk(d,k)     = 0

 DEPLIMIT: SUM(d=1:DMAX|(DKAPNY(d) .gt. DKAP(d)) .and. (DKAP(d)=0))  &
	   eNDREDEP(d) -                                             &
	   SUM(d=1:DMAX | DKAPNY(d) .lt. DKAP(d)) eNDREDEP(d)        < DMAXENDR

BOUNDS
 eNDREDEP(d=1:DMAX | (DKAPNY(d) .ne. DKAP(d)) .and. BETA==1) .BV.    ! Binaerv.

GENERATE

PRINT tOTKOST
PRINT pREFAVVI
PRINT fd
PRINT fk
PRINT dk
PRINT eNDREDEP
